%
% Main file for computing the reachable set of Rayleigh's problem
%
% Original distance function approach of Baier and Gerdts
%


clear all
format short
warning off all

dimu=1;         % dimension of control
N=20;           % length of control horizon

global lb;
global ub;

%%%%%% Rayleigh %%%%%%%
lb = -1.0;      % lower control bound
ub = 1.0;       % upper control bount
x0=[-5;-5];     % starting point of trajectory
t0=0.0;         % start time
T=2.5;          % end time

[R,Rsteps,Rdiff,Err] = compute_reachableset(x0, t0, T, N, [200 200], [-7 3; 0 5.5], dimu, @rayleigh_rhs, @rayleigh_rhs_u, @rayleigh_rhs_x);

figure(1);
scatter(R(:,1),R(:,2),50,Rsteps,'.');
figure(2);
scatter(R(:,1),R(:,2),50,Rdiff,'.');

save('rayleigh_200x200','R','Rsteps','Rdiff','Err');
