function [g,h] = eval_functions(u, dimu, N, x0, t0, A, b, c, rhs, lb, ub, Pl, Pu, statelb, stateub, hstep, target, grideps)

mPl = size(Pl, 1);
mPu = size(Pu, 1);
stages = size(A, 1);
dimx = size(x0, 1);

h  = zeros(N*dimx*(stages+1), 1);
g  = zeros(2*dimu*N+(mPl+mPu)*(N-1)+2*dimx, 1);

x = x0;
t = t0;

for i=1:N
	vertint = 2*dimu*(i-1) + (1:dimu);
	gidx = 2*dimu*N + (mPl+mPu)*(i-1);
    hidx = (i-1)*dimx*(stages+1)+(1:dimx);
    kidx = N*dimu+dimx*N+(i-1)*stages*dimx+(1:dimx);
    uidx = (i-1)*dimu+(1:dimu);
    ushootidx = N*dimu+(i-1)*dimx+(1:dimx);
    
    for j=1:stages
        tempx = 0;
        for l=1:stages
            tempx = tempx + A(j,l).*u(kidx+(l-1)*dimx);
        end
        h(hidx+(j-1)*dimx) = rhs(t + c(j)*hstep, x+hstep.*tempx, u(uidx)) - u(kidx+(j-1)*dimx);
    end
    tempx = 0;
    for l=1:stages
        tempx = tempx + b(l).*u(kidx+(l-1)*dimx);
    end
    h(hidx+stages*dimx) = x+hstep.*tempx - u(ushootidx);
    
	g(vertint) = (ub - u(uidx));
	g(vertint+dimu) = (u(uidx) - lb);
	if i==N
		if mPu>0
			g(gidx+(1:dimx)) = Pu'*min([stateub, Pu*(grideps+target)]')' + (eye(dimx)-Pu'*Pu)*(grideps+target)  - u(ushootidx);
		else
			g(gidx+(1:dimx)) = grideps+target - u(ushootidx);
		end
		if mPl>0
			g(gidx+dimx+(1:dimx)) = u(ushootidx) - (Pl'*max([statelb, Pl*(target-grideps)]')' + (eye(dimx)-Pl'*Pl)*(target-grideps));
		else
			g(gidx+dimx+(1:dimx)) = u(ushootidx) - (target-grideps);
		end
	end

	if i < N
		if mPu>0
			g(gidx+(1:mPu)) = stateub - Pu*u(ushootidx);
		end
		if mPl>0
			g(gidx+mPu+(1:mPl)) = Pl*u(ushootidx) - statelb;
		end
		
		x = u(ushootidx);
       	t = t+hstep;
	end
end

