function [x,err,steps,outersteps,s,z,y,B,m_b, s_b, y_b,value] = ip(x0, s0, z0, y0, B0, m_b0, s_b0, y_b0, eval_gh, eval_gh_grad, mg, mh, eps, infsteps, delta_b, maxsteps, bfgsmethod, lbfgssteps);

    max_m_b = 0;
    n = size(x0,1);
    B=0;
    m_b=0;
    s_b=0;
    y_b=0;
    Bcomputed = 0;
    value=inf;

    switch bfgsmethod
        case 'bfgs'
            method=1;
            if size(B0,1) == 0
                B0=eye(n)*delta_b;
            end
        case 'lbfgs'
            method=2;
            max_m_b = lbfgssteps;
            if size(s_b0,1) == 0 || size(y_b0,1)==0
                m_b = 0;
                s_b = zeros(n,max_m_b);
                y_b = zeros(n,max_m_b);
                count_b = 0;
            else
                m_b = m_b0;
                s_b = s_b0;
                y_b = y_b0;
                count_b = m_b;
                Bcomputed=1;
            end
        otherwise
            fprintf('unknown bfgs method specified. expected ''bfgs'' or ''lbfgs''\n');
            err=1;
            x=0;
            steps=0;
            outersteps=0;
            return;
    end

    mu = 0.99;

    if size(z0,1) == 0
        z = zeros(mg,1);
    else
        z = z0;
    end;

    if size(s0,1) == 0
        s = ones(mg,1);
    else
        s = s0;
    end;

    if size(y0,1) == 0
        y = zeros(mh,1);
    else
        y = y0;
    end;

    minustau = 0.005;
    outereps = inf;
    outersteps = 0;
    steps = 0;

    x=x0;

    err=0;

    p_x=zeros(n,1);
    p_s=zeros(mg,1);
    p_y=zeros(mh,1);
    p_z=zeros(mg,1);

    infeasiblecounter=0;

    while outereps > eps && steps < maxsteps
        tau = 1-minustau;
        innereps = inf;
        while innereps > mu && innereps > eps && steps < maxsteps
            steps = steps+1;

            Z = diag(z);
            S = diag(s);
            sig = inv(S)*Z;
            if steps==1
                [g_temp, h_temp, gx_temp, hx_temp] = eval_gh_grad(x);
            end;

            b= [hx_temp'*y+gx_temp'*(z-sig*g_temp+mu*inv(S)*ones(mg,1)) ; -h_temp];

            switch method
                case 1
                    if Bcomputed == 0
                        B=B0;
                        Bcomputed=1;
                    else
                        theta = 1.0;
                        Bsk=B*sk;
                        skBsk = sk'*Bsk;
                        if sk'*yk < 0.2*skBsk
                            theta = (0.8*skBsk)/(skBsk - sk'*yk);
                        end
                        rk=theta*yk + (1-theta)*Bsk;
                        B = B - (Bsk*Bsk')/(skBsk) + (rk*rk')/(sk'*rk);
                    end
                    A= [B+gx_temp'*sig*gx_temp, hx_temp' ; hx_temp, zeros(mh)];

                    p=A\b;

                    p_x = p(1:n);
                    p_y = -p(n+1:n+mh);
                    p_s = g_temp - s + gx_temp*p_x;
                    p_z = -sig*p_s - z + mu*inv(S)*ones(mg,1);
                case 2

                    tinv = inv([delta_b*eye(n)+gx_temp'*sig*gx_temp, hx_temp';hx_temp,zeros(mh,mh)]);

                    %A^-1*b -> erg2;
                    p=tinv*b;

                    p_x = p(1:n);
                    p_y = -p(n+1:n+mh);
                    p_s = gx_temp*p_x - s + g_temp;
                    p_z = -sig*p_s + mu*inv(S)*ones(mg,1) - z;

                    if Bcomputed==1
                        L_b=zeros(m_b);
                        D_b=zeros(m_b);
                        for i=2:m_b
                            for j=1:i-1
                                L_b(i,j) = s_b(:,i)'*y_b(:,j);
                            end
                        end
                        for i=1:m_b
                            D_b(i,i) = s_b(:,i)'*y_b(:,i);
                        end

                        W_b=[delta_b*s_b(:,1:m_b), y_b(:,1:m_b)];
                        M_b=inv( [s_b(:,1:m_b)'*delta_b*s_b(:,1:m_b), L_b ; L_b', -D_b]  );
                        MWt_b = M_b*W_b';

                        d_b=tinv*[W_b;zeros(mh,2*m_b)];
                        e_b=MWt_b*p(1:n);
                        f_b=inv(eye(2*m_b) + MWt_b*d_b(1:n,:))*e_b;
                        p=p-d_b*f_b;

                   p_x = p(1:n);
                   p_y = -p(n+1:n+mh);
                   p_s = gx_temp*p_x - s + g_temp;
                   p_z = -sig*p_s + mu*inv(S)*ones(mg,1) - z;

                    else
                        Bcomputed = 1;
                    end
            end

            nu=1.0;
            phi0 = merit(x, s,nu, p_x, p_s, 0, eval_gh, mu, mg, mh, g_temp, h_temp);
            dphi0 = merit_alpha_zero(s, nu, p_x, p_s, g_temp, h_temp, gx_temp, hx_temp, mu, mg, mh);


            if dphi0 > 0
                p_x = -p_x;
                p_s = -p_s;
                p_y = -p_y;
                p_z = -p_z;
                dphi0 = -dphi0;
            end

            alpha_s = 10.0;
            alpha_z = 1.0;
            for i=1:mg
                if p_s(i)<0
                    new_alpha = -tau*s(i)/p_s(i);
                    if new_alpha < alpha_s
                        alpha_s = new_alpha;
                    end
                end
                if p_z(i)<0
                    new_alpha = -tau*z(i)/p_z(i);
                    if new_alpha < alpha_z
                        alpha_z = new_alpha;
                    end
                end
            end

            phia = merit(x, s,nu, p_x, p_s, alpha_s, eval_gh, mu, mg, mh, [], []);
            while phia > phi0 + 1e-4*alpha_s*dphi0
                alpha_s = min([ alpha_s, (-dphi0*(alpha_s^2))/(2*(phia - phi0 - dphi0*alpha_s))]);

                if alpha_s < eps*1e-2
                    err=3;
                    return;
                end

                phia = merit(x, s,nu, p_x, p_s, alpha_s, eval_gh, mu, mg, mh, [], []);
            end

            oldx = x;
            old_g = gx_temp;
            old_h = hx_temp;

            s = s + alpha_s*p_s;
            z = z + alpha_z*p_z;
            x = x + alpha_s*p_x;
            y = y + alpha_z*p_y;

            if isnan(norm(x,inf)) || isnan(norm(s,inf)) || isnan(norm(z,inf))
                err=2;
                return;
            end

            [g_temp, h_temp, gx_temp, hx_temp] = eval_gh_grad(x);

            yk = (-gx_temp'*z - hx_temp'*y) - (-old_g'*z - old_h'*y);
            sk = x - oldx;

            if method == 2
                if abs(sk'*yk)>0.0 && 0
                    m_b = min([m_b + 1, max_m_b]);
                    count_b = count_b + 1;
                    if count_b > max_m_b
                        count_b = 1;
                    end;
                    y_b(:,count_b) = yk;
                    s_b(:,count_b) = sk;
                else
                    if m_b==0
                        Bcomputed=0;
                    end
                end
            end

            g_temppos = -1*g_temp;
            for i=1:mg
                if g_temppos(i) < 0.0
                    g_temppos(i)=0.0;
                end
            end
            oldeps = innereps;
            innereps = max(abs([ g_temppos; abs(h_temp) ]));
            value=innereps;
            inffac = innereps/oldeps;
            if inffac > 0.95
                infeasiblecounter = infeasiblecounter+1;
                if infeasiblecounter==infsteps
                    err=4;
                    return;
                end
            else
                infeasiblecounter=0;
            end
        end

        outereps = innereps;
        minprod = inf;
        for i=1:mg
            if abs(z(i)*s(i)) < minprod
                minprod = s(i)*z(i);
            end
        end


        sz_avg = abs((s'*z)/mg);
        xi = minprod/( sz_avg );
        sigma = 0.05*(1-xi)/xi;
        if sigma > 2
            sigma = 2;
        end
        sigma = 0.1*sigma;

        mu = sigma *sz_avg;
        minustau = sigma*0.1;

        outersteps = outersteps +1;
    end

    if steps==maxsteps
        err=1;
    end

end


function y = merit(x, s, nu, p_x, p_s, alpha, eval_gh, mu,mg,mh, eval_g, eval_h)

    s = s + p_s*alpha;
    x = x + p_x*alpha;

    if size(eval_g,1)==0
        [eval_g, eval_h] = eval_gh(x);
    end

    temp = 0.0;
    for i=1:mg
        temp = temp + log(s(i));
    end

    tempg = 0.0;
    for i=1:mg

    %	tempg = tempg + (eval_g(i) - s(i))^2;
        if eval_g(i) < 0.0
            tempg = tempg + abs(eval_g(i));

        end
    end

    for i=1:mh
    %	tempg = tempg + eval_h(i)^2;
        tempg = tempg + abs(eval_h(i));
    end

    y = -mu*temp + nu*tempg;

end



function y = merit_alpha_zero(s, nu, p_x, p_s, g, h, dg, dh, mu, mg, mh)

    logsi = 0;
    gi = 0;
    for i=1:mg
        logsi = logsi + p_s(i)/s(i);
        if g(i) < 0.0
            gi = gi - dg(i,:)*p_x;
        end
    end

    hi = 0;
    for i=1:mh
        hi = hi + dh(i,:)*p_x*sign(h(i));
    end

    y = -mu*logsi + nu*(gi + hi);


end