clear all
format short
warning off all

dimu=1;
N=20;

%%%%%% Rayleigh %%%%%%%
lb = -1.0;
ub = 1.0;
x0=[-5;-5];
t0=0.0;
T=2.5;
statelb=[];
stateub=[];
Pl=[];
Pu=[];

tic
[R,Rsteps,Bsize] = compute_reachableset(x0, t0, T, N, [200 200], [-7 3; 0 5.5], 1.2, dimu, lb, ub, Pl, Pu, statelb, stateub, @rayleigh_rhs, @rayleigh_rhs_u, @rayleigh_rhs_x);
toc

figure(1);
scatter(R(:,1),R(:,2),50,Rsteps,'.');
title('Iteration Steps');
xlabel('x_1');
ylabel('x_2');

figure(2);
plot(0:(100/(length(Bsize)-1)):100,Bsize);
title('Progress of FIFO buffer size');
xlabel('Algorithm process (%)');
ylabel('FIFO buffer size (number of problems)');

save('rayleigh_200x200','R','Rsteps');

