#ifndef ALGORITHMCUDAHEADER_H
#define ALGORITHMCUDAHEADER_H

namespace Algorithm
{

void initConstants(int dimu, int dimx, int stages, int nrhs, double * rkb, double hstep,
	int size_dfu, int size_dfx, int size_dfxA, int size_y13, int size_y24, int size_y579, int size_y6810,
	int size_Dmerge, int size_Q1, int size_Q2, int size_R, int size_rhs);

void cuda_evmrpr(
	const int & dimu, const int & dimx, const int & stages, double * const & dfu, double * const & dfx, double * const & dfxA, double * const & xi,
    double * const & y1, double * const & y3, double * const & y5, double * const & y7, double * const & y9,
    const int & bidx, const int & bsz, double * const & rhs, 
    const int & nqu, const int & nqx, 
    double * const & Q1, double * const & Q2, double * const & R, double * const &  D, const bool & iQ2, int * const & Bcomputed,
	unsigned int * const & storageidx, const int & storagesize, int * const & returncode, cudaStream_t & stream
	);

void cuda_evmrge(
	const int & dimu, const int & dimx, const int & stages, double * const & dfu, double * const & dfx, double * const & dfxAt, double * const & xi,
    double * const & y1, double * const & y2, double * const & y3, double * const & y4, double * const & y5,
    double * const & y6, double * const & y7, double * const & y8, double * const & y9, double * const & y10, 
    const int & bidx, const int & bsz, double * const & rhs, 
    const int & nqu, const int & nqx, 
    double * const & Q1, double * const & Q2, double * const & R, double * const &  D, const bool & iQ2, int * const & Bcomputed,
	unsigned int * const & storageidx, const int & storagesize, int * const & returncode, cudaStream_t & stream
	);


}


#endif