#ifndef OPTCHOLSCHEDULER_H
#define OPTCHOLSCHEDULER_H

namespace OptChol
{

class Scheduler
{
public:
	typedef struct
	{
		int * n_rhselim;
		int * n_matrixelim;
		int * n_backsubst;
		int * n_nonzeros;
		int * sdiag;
		int * mapped_sdiag;
		int * nonzeros;
		int * mapped_rhselim;
		int * rhselim;
		int * mapped_matrixelim;
		int * backsubst;
		int n;
		int total_nonzeros;
		int total_rhselim;
		int total_matrixelim;
		int total_backsubst;
		int problemsperblock;
		int threadsperstid;
		int sharedmemsize;
		int trans_problemsperblock;
		int trans_rows;
		int trans_sharedmemsize;
		int rhs_problemsperblock;
		int rhs_threadsperstid;
		int rhs_sharedmemsize;
	} T_CUDADATA;

	virtual ~Scheduler() = 0;
	static int * generate(int n, double * A);
	static void createCUDAData(int n, int * packedinfo, T_CUDADATA & cudadata);
	static void destroyCUDAData(T_CUDADATA & cudadata);

private:

	Scheduler() {}

};


}


#endif